<div class="flex-column full-height full-width" style="overflow-y: hidden">
  <div
    class="flex-row p-r-10"
    style="justify-content: space-between; align-items: center"
  >
    <div class="sqtm-large-grid-container-title flex-column">
      {{ 'sqtm-core.test-case-workspace.title.test-steps' | translate }}
    </div>
    <div class="flex-row">
      <i
        nz-icon
        nzType="sqtm-core-generic:read"
        nzTheme="outline"
        class="action-icon-size current-workspace-main-color __hover_pointer"
        [nz-tooltip]="
          'sqtm-core.test-case-workspace.test-steps.button.script-preview'
            | translate
        "
        (click)="showScriptPreview()"
        [attr.data-test-button-id]="'preview-script-icon'"
      >
      </i>

      <sqtm-core-toggle-icon
        [attr.data-test-toolbar-button-id]="'copy-button'"
        [active]="hasSelectedSteps$ | async"
        (clickedInActiveMode)="copyTestSteps()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:copy"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.copy' | translate"
          nzTooltipPlacement="topRight"
          class="m-l-10 action-icon-size"
        ></i>
      </sqtm-core-toggle-icon>
      @if (editable) {
        <div class="flex-row">
          <sqtm-core-toggle-icon
            class="m-l-10"
            [attr.data-test-toolbar-button-id]="'paste-button'"
            [active]="canPaste$ | async"
            (clickedInActiveMode)="pasteTestSteps()"
          >
            <i
              nz-icon
              nzType="sqtm-core-generic:paste"
              nzTheme="outline"
              nz-tooltip
              class="action-icon-size"
              [nzTooltipTitle]="'sqtm-core.generic.label.paste' | translate"
              nzTooltipPlacement="top"
            ></i>
          </sqtm-core-toggle-icon>
        </div>
      }

      @if (editable) {
        <sqtm-core-toggle-icon
          class="m-l-10"
          [attr.data-test-toolbar-button-id]="'delete-button'"
          [active]="hasSelectedSteps$ | async"
          (clickedInActiveMode)="deleteTestSteps()"
        >
          <i
            nz-icon
            nzType="sqtm-core-generic:delete"
            nzTheme="outline"
            nz-tooltip
            class="action-icon-size"
            [nzTooltipTitle]="
              'sqtm-core.entity.test-step.delete-multiple' | translate
            "
            nzTooltipPlacement="topRight"
          ></i>
        </sqtm-core-toggle-icon>
      }
    </div>
  </div>
  @if (editable) {
    <div
      class="add-step-grid p-r-10"
      [style.grid-template-rows]="actionWordLibraryActive ? '80px' : '55px'"
      [formGroup]="addKeywordStepFormGroup"
    >
      <div class="label-and-select-field">
        <sqtm-core-label
          [text]="
            'sqtm-core.test-case-workspace.test-steps.label.add-keyword-step'
              | translate
          "
        >
        </sqtm-core-label>
        <sqtm-core-select-field
          [formGroup]="addKeywordStepFormGroup"
          [fieldName]="'keyword'"
          [options]="getDisplayedKeyword()"
        >
        </sqtm-core-select-field>
      </div>
      @if (actionWordLibraryActive) {
        <div class="input-and-filter">
          <sqtm-core-action-autocomplete-field
            #actionField
            [formGroup]="addKeywordStepFormGroup"
            [fieldName]="'action'"
            [placeholder]="
              'sqtm-core.test-case-workspace.test-steps.label.enter-action'
                | translate
            "
            [options]="matchingActionWords"
            (valueChanged)="getMatchingActionWords($event)"
            (confirmValueEvent)="addStep($event)"
          >
          </sqtm-core-action-autocomplete-field>
          <div class="filter-container flex-row m-t-10">
            <sqtm-core-label
              class="m-t-3"
              [text]="'sqtm-core.action-word-workspace.filter' | translate"
            >
            </sqtm-core-label>
            <div
              #scopeSelector
              class="filter-field p-3 __hover_pointer flex-row m-l-10"
              [attr.data-test-element-id]="'grid-scope-field'"
              (click)="openProjectsFilter()"
            >
              <div
                class="txt-ellipsis"
                nz-tooltip
                [sqtmCoreLabelTooltip]="projectDisplayValue"
              >
                <span class="label-color"
                  >{{
                    'sqtm-core.entity.project.label.plural' | translate
                  }}
                  :&nbsp;</span
                >
                <span [attr.data-test-element-id]="'grid-scope-value'">{{
                  projectDisplayValue
                }}</span>
              </div>
            </div>
          </div>
        </div>
      } @else {
        <sqtm-core-action-text-field
          #actionField
          [formGroup]="addKeywordStepFormGroup"
          [fieldName]="'action'"
          [placeholder]="
            'sqtm-core.test-case-workspace.test-steps.label.enter-action'
              | translate
          "
          (keyup.enter)="addStep($event)"
        >
        </sqtm-core-action-text-field>
      }
    </div>
  }

  <div
    class="full-width full-height flex-column"
    style="overflow-y: auto; overflow-x: hidden"
    [sqtmCoreDraggableList]="origin"
    [dragEnabled]="editable"
    [draggedContentRenderer]="draggedStepComponent"
    (dragStart)="dragStart($event)"
    (dragOver)="dragOver($event)"
    (dragCancel)="dragCancel()"
    (dragLeave)="dragLeave($event)"
    (drop)="drop($event)"
  >
    <div class="full-width p-r-10">
      @for (step of filterKeywordSteps(); track trackStepFn($index, step)) {
        @if (step.kind === 'keyword-step') {
          <sqtm-app-keyword-step
            [keywords]="keywords"
            [keywordStep]="step"
            [editable]="editable"
            [linkable]="linkable"
            [autocompleteActive]="actionWordLibraryActive"
          >
          </sqtm-app-keyword-step>
        }
      }
    </div>
    <div
      class="last-position-drop-zone"
      [sqtmCoreDraggableListItem]="lastPositionDropZone"
      [enableDrag]="false"
    ></div>
  </div>
</div>
